<template>
  <div
    class="dropdown-wrapper"
    v-if="dropDownIsVisible"
    :style="{
      right: dropdownPosition.right,
      left: dropdownPosition.left,
      bottom: dropdownPosition.bottom,
      top: dropdownPosition.top,
      width: props.dropdownWidth
    }"
    v-click-outside="outside"
  >
    <div class="dropdown-container">
      <div class="dropdown-arrow" :style="{ right: arrow.right }" v-if="arrow.show" />
      <slot name="drop_content"></slot>
    </div>
  </div>
</template>

<script setup>
const props = defineProps({
  dropdownWidth: {
    type: String,
    default: '100%'
  },
  dropdownPosition: {
    type: Object,
    default: () => {}
  },
  dropDownIsVisible: {
    type: Boolean,
    default: false
  },
  arrow: {
    type: Object,
    default: () => {}
  },
});

const emit = defineEmits(["update:dropDownIsVisible"]);
const outside = () => {
  emit("update:dropDownIsVisible", false);
};
onMounted(() => {
  document.addEventListener("keyup", (e) => {
    if (e.code == "Escape") {
      emit("update:dropDownIsVisible", false)

    };
  });
});
</script>

<style lang="sass" scoped>
@import '/assets/styles/_variables.sass'
.dropdown
    &-wrapper
        margin: 2rem
        position: absolute
        font-weight: normal
        background: #ffff
        border-radius: 5px
    &-container
        width: 100%
        border-radius: 5px
        border: 1px solid $darkgrey
        box-shadow: 1px 0px 8px rgba(0, 0, 0, 0.25)
        position: relative
    &-arrow
        width: 1rem
        height: 1rem
        border-top: 1px solid $darkgrey
        border-left: 1px solid $darkgrey
        background: $white
        transform: rotate(45deg)
        position: absolute
        top: -9px
        right: 15px
</style>
